set mxloops 5000.
matrix.
get limits/variables=limits/missing=omit.
get data/variables data condition block/missing omit.
compute nrows=limits(1)*2.
compute nblock=limits(1).
compute total={0,0}.
loop row=1 to nrows.
compute total(data(row,2))=total(data(row,2))+data(row,1).
end loop.
compute test=(total(2)-total(1))/nblock.
print test/title="test statistic".
compute nperm=2001.
compute results=uniform(nperm,1).
compute results(1,1)=test-test/1000000.
loop perm=2 to nperm.
loop bl = 1 to nblock.
loop tr = 1 to 2.
compute k=trunc(uniform(1,1)*(2-tr+1))+tr+2*(bl-1).
compute row=tr+2*(bl-1).
compute temp=data(row,1).
compute data(row,1)=data(k,1).
compute data(k,1)=temp.
end loop.
end loop.
compute total={0,0}.
loop row=1 to nrows.
compute total(data(row,2))=total(data(row,2))+data(row,1).
end loop.
compute test=(total(2)-total(1))/nblock.
compute results(perm,1)=test.
end loop.
compute absres=abs(results).
compute pos1=0.
compute pos2=0.
loop k=2 to nperm.
do if results(k,1)>=results(1,1).
compute pos1=pos1+1.
end if.
do if absres(k,1)>=absres(1,1).
compute pos2=pos2+1.
end if.
end loop.
print pos1/title="count of arrangement statistics at least as large".
compute prob1=(pos1+1)/nperm.
print prob1/title="one tail probability".
print pos2/title="count of arrangement statistics at least as large in abs value as abs(test)".
compute prob2=(pos2+1)/nperm.
print prob2/title="two tail probability".
end matrix.

