set mxloops 5000.
matrix.
get limits/variables=limits/missing=omit.
get data/variables data condition participant/missing omit.
compute ncase=limits(1).
compute nswaps=limits(2).
compute nobs=ncase*nswaps.
compute total={0,0}.
loop obs=1 to nobs.
compute total(data(obs,2))=total(data(obs,2))+data(obs,1).
end loop.
compute test1=(total(2)-total(1))/(nobs/2).
print test1/title="test statistic".
compute nperm=2001.
compute results=uniform(nperm,1).
compute results(1,1)=test1-test1/1000000.
loop perm=2 to nperm.
loop case = 1 to ncase.
loop n= 1 to nswaps.
compute k=trunc(uniform(1,1)*(nswaps-n+1))+n+nswaps*(case-1).
compute obs=n+nswaps*(case-1).
compute temp=data(obs,1).
compute data(obs,1)=data(k,1).
compute data(k,1)=temp.
end loop.
end loop.
compute total={0,0}.
loop obs=1 to nobs.
compute total(data(obs,2))=total(data(obs,2))+data(obs,1).
end loop.
compute test1=(total(2)-total(1))/(nobs/2).
compute results(perm,1)=test1.
end loop.
compute absres=abs(results).
compute pos1=0.
compute pos2=0.
loop k=2 to nperm.
do if results(k,1)>=results(1,1).
compute pos1=pos1+1.
end if.
do if absres(k,1)>=absres(1,1).
compute pos2=pos2+1.
end if.
end loop.
print pos1/title="count of arrangement statistics at least as large".
compute prob1=(pos1+1)/nperm.
print prob1/title="one tail probability".
print pos2/title="count of arrangement statistics at least as large in abs value as abs(test)".
compute prob2=(pos2+1)/nperm.
print prob2/title="two tail probability".
end matrix.